﻿var diagram;
$(document).ready(function () {

    diagram = $("#DiagramContent").ejDiagram("instance");

});

function updateIntelligentNode(args) {
    var node = args.element;
    var points = null;
    var str = node.name.toString();
    if (str) {
        if (str.match("5star")) {
            points = _updateStar(node, diagram._svg, 5, 25);
            node.shape.pathData = points;
            return points;
        }
        else if (str.match("16star")) {
            points = _updateStar(node, diagram._svg, 16, 25);
            node.shape.pathData = points;
            return points;
        }
        else if (str.match("6star")) {
            points = _updateStar(node, diagram._svg, 6, 25);
            node.shape.pathData = points;
            return points;
        }
        else if (str.match("LeftArrow") && !str.match("CurvedLeftArrow") && !str.match("JumpingLeftArrow")) {
            points = _updateLeftArrow(node, diagram._svg);
            node.shape.pathData = points;
            return points;
        }
        else if (str.match("RightArrow") && !str.match("CurvedRightArrow") && !str.match("JumpingRightArrow")) {
            points = _updateRightArrow(node, diagram._svg);
            node.shape.pathData = points;
            return points;
        }
        else if (str.match("Parallelogram")) {
            points = _updatePallelogram(node, diagram._svg);
            node.shape.pathData = points;
            return points;
        }
        else if (str.match("bendsingleArrow")) {
            points = _updateBendSingleArrow(node, diagram._svg);
            node.shape.pathData = points;
            return points;
        }
        else if (str.match("benddoubleArrow")) {
            points = _updateBenddoubleArrow(node, diagram._svg);
            node.shape.pathData = points;
            return points;


        }
        else if (str.match("DoubleArrow")) {
            points = _updateDoubleArrow(node, diagram._svg);
            node.shape.pathData = points;
            return points;
        }
        else if (str.match("quradicArrow")) {
            points = _updateQuradicArrow(node, diagram._svg);
            node.shape.pathData = points;
            return points;

        }
        else if (str.match("Column")) {
            points = _updateGridColumn(node, diagram._svg);
            node.shape.pathData = points;
            return points;
        }
        else if (str.match("Row")) {
            points = _updateGridRow(node, diagram._svg);
            node.shape.pathData = points;
            return points;

        }
        else if (str.match("Hexagon")) {
            points = _updateOctogan(node, diagram._svg, args);
            node.shape.pathData = points;
            return points;
        }
        else if (str.match("RoundedRectangle")) {
            points = _updateRRectangle(node, diagram._svg);
            node.shape.pathData = points;
            return points;

        }
        else if (str.match("StoredData")) {
            //points = _updateStoredData(node);
            //node.shape.pathData = points;
            //return points;

        }
    }
};


function _renderStar(node, count, radius) {
    var oRadius = 0;
    if (node.height > node.width)
        oRadius = node.width / 2;
    else
        oRadius = node.height / 2;

    var points = this._updateStarPoints(node.width / 2, node.height / 2, count, oRadius, radius);

    var mx = node.pinX - node.width / 2;
    var my = node.pinY - node.height / 2;
    for (var i = 0, len = points.length; i < len; ++i) {
        var point = this.translate(points[i], 0, 0);
        points[i] = point;
    }
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape",  "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;
};

function _renderDoubleArrow(node) {

    var points = this._updateDoubleArrowPoints(node);
    //var mx = node.pinX - node.width / 2;
    //var my = node.pinY - node.height / 2;
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape", "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;
};

function _renderLeftArrow(node) {
    var points = this._updateLeftArrowPoints(node);
    //var mx = node.pinX - node.width / 2;
    //var my = node.pinY - node.height / 2;
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape", "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;
};

function _renderRightArrow(node) {
    var points = this._updateRightArrowPoints(node);
    //var mx = node.pinX - node.width / 2;
    //var my = node.pinY - node.height / 2;
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape", "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;
};

function _renderQuradicArrow(node) {

    var points = this._updateQudraticArrowPoints(node);
    //var mx = node.pinX - node.width / 2;
    //var my = node.pinY - node.height / 2;
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape", "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;
};

function _renderRRectangle(node) {
    var points = this._updateRoundedRectanglePoints(node);

    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape", "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;
};

function _renderParallelogram(node) {
    var points = this._updateParallelogramPoints(node);

    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape", "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;

};

function _renderBendSingleArrow(node) {
    var points = this._updateBendSingleArrowPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape", "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;
};

function _renderBenddoubleArrow(node) {
    var points = this._updateBenddoubleArrowPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape", "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;
};

function _renderOctagon(node) {

    var points = this._updateOctagonPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape", "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;
};

function _renderDiamond(node) {
    var points = this._updateDiamondPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape", "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;

};

function _renderGridColumn(node) {
    var points = this._updateGridColumnPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape", "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;
};

function _renderGridRow(node) {
    var points = this._updateGridRowPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //var svgpoints = this._convertToSVGPoints(points);
    //var attr = {
    //    "id": node.name + "_shape", "stroke": node.borderColor,
    //    "stroke-width": node.borderWidth, "opacity": node.opacity,
    //    "stroke-dasharray": node.borderDashArray, "points": svgpoints
    //};
    return points;
};

function _renderStoredData(node) {
    var points = this._updateStoredDataPoints(node);
    return points;
};

function _updateStar(node, svg, count, radius) {
    var oRadius = 0;
    if (node.height > node.width)
        oRadius = node.width / 2;
    else
        oRadius = node.height / 2;

    var points = this._updateStarPoints(node.width / 2, node.height / 2, count, oRadius, radius);
    var mx = node.pinX - node.width / 2;
    var my = node.pinY - node.height / 2;
    for (var i = 0, len = points.length; i < len; ++i) {
        var point = this.translate(points[i], 0, 0);
        points[i] = point;
    }

    return points;
    //  svg.polygon({ "id": node.name + "_shape", "points": this._convertToSVGPoints(points) });
};

function _updateDoubleArrow(node, svg) {

    var points = this._updateDoubleArrowPoints(node);

    var mx = node.pinX - node.width / 2;
    var my = node.pinY - node.height / 2;
    for (var i = 0, len = points.length; i < len; ++i) {
        var point = this.translate(points[i], 0, 0);
        points[i] = point;
    }
    // svg.polygon({ "id": node.name + "_shape", "points": this._convertToSVGPoints(points) });

    return points;
};

function _updateLeftArrow(node, svg) {
    var points = this._updateLeftArrowPoints(node);
    var mx = node.pinX - node.width / 2;
    var my = node.pinY - node.height / 2;
    for (var i = 0, len = points.length; i < len; ++i) {
        var point = this.translate(points[i], 0, 0);
        points[i] = point;
    }
    // svg.polygon({ "id": node.name + "_shape", "points": this._convertToSVGPoints(points) });

    return points;
};

function _updateRightArrow(node, svg) {
    var points = this._updateRightArrowPoints(node);
    var mx = node.pinX - node.width / 2;
    var my = node.pinY - node.height / 2;
    for (var i = 0, len = points.length; i < len; ++i) {
        var point = this.translate(points[i], 0, 0);
        points[i] = point;
    }
    // svg.polygon({ "id": node.name + "_shape", "points": this._convertToSVGPoints(points) });

    return points;
};

function _updateQuradicArrow(node, svg) {
    var points = this._updateQudraticArrowPoints(node);
    var mx = node.pinX - node.width / 2;
    var my = node.pinY - node.height / 2;
    for (var i = 0, len = points.length; i < len; ++i) {
        var point = this.translate(points[i], 0, 0);
        points[i] = point;
    }
    // svg.polygon({ "id": node.name + "_shape", "points": this._convertToSVGPoints(points) });

    return points;
};

function _updateRRectangle(node, svg) {
    var points = this._updateRoundedRectanglePoints(node);



    //svg.polygon({ "id": node.name + "_shape", "points": this._convertToSVGPoints(points) });

    return points;
    //svg.polygon({ "id": node.name + "_shape", "points": this._convertToSVGPoints(points) });;
}

function _updatePallelogram(node, svg) {
    var points = this._updateParallelogramPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    // svg.polygon({ "id": node.name + "_shape", "points": this._convertToSVGPoints(points) });

    return points;
};

function _updateBendSingleArrow(node, svg) {
    var points = this._updateBendSingleArrowPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    //svg.polygon({ "id": node.name + "_shape", "points": this._convertToSVGPoints(points) });

    return points;
};

function _updateBenddoubleArrow(node, svg) {
    var points = this._updateBenddoubleArrowPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}
    // svg.polygon({ "id": node.name + "_shape", "points": this._convertToSVGPoints(points) });

    return points;
};

function _updateOctogan(node, svg, args) {
    var points = this._updateOctagonPoints(node, args);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}

    return points;
};

function _updateDiamond(node) {
    var points = this._updateDiamondPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}

    return points;
};

function _updateGridColumn(node) {
    var points = this._updateGridColumnPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}

    return points;
};

function _updateGridRow(node) {
    var points = this._updateGridRowPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}

    return points;
};

function _updateStoredData(node) {
    var points = this._updateStoredDataPoints(node);
    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}

    return points;
};

function _updateStarPoints(cx, cy, spikes, outerRadius, innerRadius) {
    var rot = Math.PI / 2 * 3;
    var x = cx;
    var y = cy;
    var step = Math.PI / spikes;
    var points = [];
    for (var i = 0; i < spikes; i++) {
        x = cx + Math.cos(rot) * outerRadius;
        y = cy + Math.sin(rot) * outerRadius;
        points.push({ x: x, y: y });
        rot += step;
        if (i <= spikes) {
            x = cx + Math.cos(rot) * innerRadius;
            y = cy + Math.sin(rot) * innerRadius;
            points.push({ x: x, y: y });
        }
        rot += step;
    }
    return points;
};

function _updateDoubleArrowPoints(node, option) {
    var x = 0;
    var y = 0;
    var points = [];
    points.push({ x: x, y: node.height / 2 });
    points.push({ x: node.height / 2, y: node.height });
    points.push({ x: node.height / 2, y: node.height - node.height / 4 });
    points.push({ x: node.width - (node.height / 2), y: node.height - node.height / 4 });
    points.push({ x: node.width - (node.height / 2), y: node.height });
    points.push({ x: node.width, y: node.height / 2 });
    points.push({ x: node.width - (node.height / 2), y: y });
    points.push({ x: node.width - (node.height / 2), y: node.height / 4 });
    points.push({ x: node.height / 2, y: node.height / 4 });
    points.push({ x: node.height / 2, y: y });
    points.push({ x: x, y: node.height / 2 });

    var str = getPathData(points);

    return str;
};

function _updateLeftArrowPoints(node) {
    var x = 0;
    var y = 0;
    var points = [];
    points.push({ x: x, y: node.height / 2 });
    points.push({ x: node.height / 2, y: node.height });
    points.push({ x: node.height / 2, y: node.height - node.height / 4 });
    points.push({ x: node.width, y: node.height - node.height / 4 });
    points.push({ x: node.width, y: node.height / 4 });
    points.push({ x: node.height / 2, y: node.height / 4 });
    points.push({ x: node.height / 2, y: y });
    points.push({ x: x, y: node.height / 2 });
    var str = getPathData(points);

    return str;
};

function _updateRightArrowPoints(node, svg, g) {
    var x = 0;
    var y = 0;
    var points = [];
    points.push({ x: x, y: (node.height - node.height / 4) });
    points.push({ x: node.width - (node.height / 2), y: node.height - node.height / 4 });
    points.push({ x: node.width - (node.height / 2), y: node.height });
    points.push({ x: node.width, y: node.height / 2 });
    points.push({ x: node.width - (node.height / 2), y: y });
    points.push({ x: node.width - (node.height / 2), y: node.height / 4 });
    points.push({ x: x, y: node.height / 4 });
    var str = getPathData(points);

    return str;
};

function _updateQudraticArrowPoints(node, option) {
    var x = 0;
    var y = 0;
    var points = [];
    //poin



    //points.push({x:0, node.height / 2});
    //points.push({x:((node.width/2) / 4), node.height/4});
    //points.push({x:((node.width / 2) / 4), node.height / 2 - ((node.height / 2) / 4)});
    //points.push({x:((node.width / 2) / 4), node.height - node.height / 4});







    //points.push({x:(node.width / 2) - ((node.width / 2) / 4), node.height / 2 - ((node.height / 2) / 4)});
    //points.push({x:((node.width / 2) / 4), node.height - node.height / 4});
    //points.push({x:((node.width / 2) / 4), node.height - node.height / 4});
    //points.push({x:((node.width / 2) / 4), node.height - (node.height/4)/2});



    //points.push({x:(node.width / 2) - ((node.width / 2) / 4), node.height - ((node.height / 2) / 4)});
    //points.push({x:(node.width / 2), 0});
    //points.push({x:node.width/2-((node.width/2)/4),node.height-((node.height/2)/4)});



    //points.push({x:node.width - (node.height / 2), node.height - node.height / 4});
    //points.push({x:node.width - (node.height / 2), node.height});
    //points.push({x:node.width, node.height / 2});
    //points.push({x:node.width - (node.height / 2), y});
    //points.push({x:node.width - (node.height / 2), node.height / 4});
    //points.push({x:node.height / 2, node.height / 4});
    //points.push({x:node.height / 2, y});
    //points.push({x:x, node.height / 2});



    return points;
};

function _updateRoundedRectanglePoints(node) {
    var x = 0;
    var y = 0;
    var points = [];

    points.push({ x: 10, y: y });
    points.push({ x: node.width - 10, y: y });
    points.push({ x: node.width, y: 10 });
    points.push({ x: node.width, y: node.height - 10 });
    points.push({ x: node.width - 10, y: node.height });
    points.push({ x: 10, y: node.height });
    points.push({ x: 0, y: node.height - 10 });
    points.push({ x: 0, y: 10 });

    //for (var i = 0, len = points.length; i < len; ++i) {
    //    var point = this.translate(points[i], 0, 0);
    //    points[i] = point;
    //}

    //  var d = "M" + 10 + "," + y + "L" + node.width - 10 + "," + y + "C" + node.width + "," + 10 + "L" + node.width + "," + node.height - 10 + "C" + node.width - 10 + "," + node.height +
    //  "L" + 10 + "," + node.height + "C" + 0 + "," + node.height - 10 + "z";


    var d = "M" + points[0].x + "," + points[0].y + "L" + points[1].x + "," + points[1].y + "A" + 5 + "," + 2 + " " + 1 + " " + 1 + "," + 1 + " " + points[2].x + "," + points[2].y + "L" + points[3].x + "," + points[3].y + "A" + 15 + "," + 5 + " " + 0 + " " + 0 + "," + 1 + "" + points[4].x + "," + points[4].y +
        "L" + points[5].x + "," + points[5].y + "A" + 10 + "," + 5 + " " + 0 + " " + 0 + "," + 0 + " " + points[6].x + "," + points[6].y + "L" + points[7].x + "," + points[7].y + "z";
    return d;
};

function _updateParallelogramPoints(node) {

    var points = [];
    points.push({ x: 10, y: 0 });
    points.push({ x: node.width, y: 0 });
    points.push({ x: node.width - 10, y: node.height });
    points.push({ x: 0, y: node.height });
    var str = getPathData(points);

    return str;
};

function _updateBendSingleArrowPoints(node) {
    var x = 0;
    var y = 0;
    var points = [];
    points.push({ x: x, y: node.height });
    points.push({ x: (node.width - ((node.width / 2) / 4)), y: node.height });
    points.push({ x: (node.width - ((node.width / 2) / 4)), y: ((node.height / 2) / 4) });
    points.push({ x: node.width, y: ((node.height / 2) / 4) });
    points.push({ x: node.width - ((node.width / 2) / 2.5), y: 0 });
    points.push({ x: (node.width / 2) + ((node.width / 2) / 4), y: ((node.height / 2) / 4) });

    points.push({ x: (node.width - (node.width / 4)), y: ((node.height / 2) / 4) });
    points.push({ x: (node.width - (node.width / 4)), y: node.height - ((node.height / 2) / 4) });
    points.push({ x: 0, y: (node.height - ((node.height / 2) / 4)) });
    points.push({ x: 0, y: node.height });
    return points;
};

function _updateBenddoubleArrowPoints(node) {
    var x = 0;
    var y = 0;
    var points = [];
    points.push({ x: 0, y: node.height - ((node.height / 2) / 2.5) });
    points.push({ x: ((node.width / 2) / 4), y: node.height });
    points.push({ x: ((node.width / 2) / 4), y: node.height - ((node.height / 2) / 4) });
    points.push({ x: (node.width - ((node.width / 2) / 4)), y: node.height - ((node.height / 2) / 4) });

    points.push({ x: (node.width - ((node.width / 2) / 4)), y: ((node.height / 2) / 4) });
    points.push({ x: node.width, y: ((node.height / 2) / 4) });
    points.push({ x: node.width - ((node.width / 2) / 2.5), y: 0 });
    points.push({ x: (node.width / 2) + ((node.width / 2) / 4), y: ((node.height / 2) / 4) });

    points.push({ x: (node.width - (node.width / 4)), y: ((node.height / 2) / 4) });
    points.push({ x: (node.width - (node.width / 4)), y: node.height - (node.height / 4) });
    points.push({ x: ((node.width / 2) / 4), y: node.height - (node.height / 4) });
    points.push({ x: ((node.width / 2) / 4), y: (node.height / 2) + ((node.height / 2) / 4) });
    return points;
};

function _updateOctagonPoints(node, args) {

    var x = 10;
    var y;
    if (node.height != 1) {
        x = (node.height / 4);
    }
    var points = [];
    points.push({ x: 0, y: node.height / 2 });
    //node.width/4
    points.push({ x: x, y: 0 });
    points.push({ x: (node.width - x), y: 0 });
    points.push({ x: node.width, y: node.height / 2 });
    points.push({ x: (node.width - x), y: node.height });
    points.push({ x: x, y: node.height });
    points.push({ x: 0, y: node.height / 2 });
    var str = getPathData(points);

    return str;
};

function _updateDiamondPoints(node) {
    var x = 0;
    var y = 0;
    var points = [];
    points.push({ x: 0, y: node.height / 2 });
    points.push({ x: node.width / 2, y: 0 });
    points.push({ x: node.width, y: node.height / 2 });
    points.push({ x: node.width / 2, y: node.height });

    return points;
};

function _updateGridColumnPoints(node) {
    var x = 0;
    var y = 0;

    var points = [];

    points.push({ x: 0, y: 0 });
    points.push({ x: 10, y: 0 });
    points.push({ x: 10, y: node.height });
    points.push({ x: 0, y: node.height });
    points.push({ x: 0, y: 0 });

    points.push({ x: 10, y: 0 });
    points.push({ x: node.width - 10, y: 0 });
    points.push({ x: node.width - 10, y: node.height });
    points.push({ x: 10, y: node.height });
    points.push({ x: 10, y: 0 });


    points.push({ x: node.width - 10, y: 0 });
    points.push({ x: node.width, y: 0 });
    points.push({ x: node.width, y: node.height });
    points.push({ x: node.width - 10, y: node.height });
    points.push({ x: node.width - 10, y: 0 });
    var str = getPathData(points);

    return str;
};

function _updateGridRowPoints(node) {
    var x = 0;
    var y = 0;
    var points = [];


    points.push({ x: 0, y: 0 });
    points.push({ x: 10, y: 0 });
    points.push({ x: 10, y: node.height });
    points.push({ x: 0, y: node.height });
    points.push({ x: 0, y: 0 });

    points.push({ x: 0, y: 0 });
    points.push({ x: node.width, y: 0 });
    points.push({ x: node.width, y: 10 });
    points.push({ x: 0, y: 10 });
    points.push({ x: 0, y: 0 });

    points.push({ x: 0, y: 0 });
    points.push({ x: 10, y: 0 });
    points.push({ x: 10, y: 10 });
    points.push({ x: node.width, y: 10 });
    points.push({ x: node.width, y: node.height });
    points.push({ x: 10, y: node.height });
    points.push({ x: 10, y: 10 });
    points.push({ x: 0, y: 10 });
    points.push({ x: 0, y: 0 });

    var str = getPathData(points);

    return str;
};

function _updateStoredDataPoints(node) {
    var x = 10;
    var y;
    if (node.height != 1) {
        x = (node.height / 4);
    }
    var points = [];
    points.push({ x: 0, y: node.height / 2 });
    //node.width/4
    points.push({ x: x, y: 0 });
    points.push({ x: (node.width - x), y: 0 });
    points.push({ x: node.width, y: node.height / 2 });
    points.push({ x: (node.width - x), y: node.height });
    points.push({ x: x, y: node.height });
    points.push({ x: 0, y: node.height / 2 });


    var d = "M" + points[0].x + "," + points[0].y + "L" + points[1].x + "," + points[1].y + "L" + points[2].x + "," + points[2].y +
        "C" + points[3].x + "," + points[3].y + "," + points[4].x + "," + points[4].y + "L" + points[5].x + "," + points[5].y + "L" + points[6].x + "," + points[6].y + "z";
    return d;
};

function _convertToSVGPoints(points) {
    var pts = "";
    for (var i = 0, len = points.length; i < len; i++) {
        pts += points[i].toString() + " ";
    }
    return pts.trim();
};

function translate(pt1, dx, dy) {
    return ej.datavisualization.Diagram.Point(pt1.x + dx, pt1.y + dy);
};

function getPathData(points) {
    var str;
    for (var i = 0; i < points.length; i++) {
        if (i == 0) {
            str = "M" + points[i].x + "," + points[i].y;
        }
        else {
            str += "L" + points[i].x + "," + points[i].y;
        }
        if (i == (points.length - 1)) {
            str += "z";
        }
    }
    return str;
};